---
title: 'SyntaxError: JSON.parse: bad parsing'
slug: Web/JavaScript/Reference/Errors/JSON_bad_parse
tags:
  - Error
  - Errors
  - JSON
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exceptions thrown by {{jsxref("JSON.parse()")}} occur when string failed to be parsed as JSON.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: JSON.parse: unterminated string literal
SyntaxError: JSON.parse: bad control character in string literal
SyntaxError: JSON.parse: bad character in string literal
SyntaxError: JSON.parse: bad Unicode escape
SyntaxError: JSON.parse: bad escape character
SyntaxError: JSON.parse: unterminated string
SyntaxError: JSON.parse: no number after minus sign
SyntaxError: JSON.parse: unexpected non-digit
SyntaxError: JSON.parse: missing digits after decimal point
SyntaxError: JSON.parse: unterminated fractional number
SyntaxError: JSON.parse: missing digits after exponent indicator
SyntaxError: JSON.parse: missing digits after exponent sign
SyntaxError: JSON.parse: exponent part is missing a number
SyntaxError: JSON.parse: unexpected end of data
SyntaxError: JSON.parse: unexpected keyword
SyntaxError: JSON.parse: unexpected character
SyntaxError: JSON.parse: end of data while reading object contents
SyntaxError: JSON.parse: expected property name or '}'
SyntaxError: JSON.parse: end of data when ',' or ']' was expected
SyntaxError: JSON.parse: expected ',' or ']' after array element
SyntaxError: JSON.parse: end of data when property name was expected
SyntaxError: JSON.parse: expected double-quoted property name
SyntaxError: JSON.parse: end of data after property name when ':' was expected
SyntaxError: JSON.parse: expected ':' after property name in object
SyntaxError: JSON.parse: end of data after property value in object
SyntaxError: JSON.parse: expected ',' or '}' after property value in object
SyntaxError: JSON.parse: expected ',' or '}' after property-value pair in object literal
SyntaxError: JSON.parse: property names must be double-quoted strings
SyntaxError: JSON.parse: expected property name or '}'
SyntaxError: JSON.parse: unexpected character
SyntaxError: JSON.parse: unexpected non-whitespace character after JSON data
SyntaxError: JSON.parse Error: Invalid character at position {0} (Edge)</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>{{jsxref("JSON.parse()")}} parses a string as JSON. This string has to be valid JSON and will throw this error if incorrect syntax was encountered.</p>

<h2 id="Examples">Examples</h2>

<h3 id="JSON.parse_does_not_allow_trailing_commas"><code>JSON.parse()</code> does not allow trailing commas</h3>

<p>Both lines will throw a SyntaxError:</p>

<pre class="brush: js example-bad">JSON.parse('[1, 2, 3, 4,]');
JSON.parse('{"foo": 1,}');
// SyntaxError JSON.parse: unexpected character
// at line 1 column 14 of the JSON data
</pre>

<p>Omit the trailing commas to parse the JSON correctly:</p>

<pre class="brush: js example-good">JSON.parse('[1, 2, 3, 4]');
JSON.parse('{"foo": 1}');</pre>

<h3 id="Property_names_must_be_double-quoted_strings">Property names must be double-quoted strings</h3>

<p>You cannot use single-quotes around properties, like 'foo'.</p>

<pre class="brush: js example-bad">JSON.parse("{'foo': 1}");
// SyntaxError: JSON.parse: expected property name or '}'
// at line 1 column 2 of the JSON data</pre>

<p>Instead write "foo":</p>

<pre class="brush: js example-good">JSON.parse('{"foo": 1}');</pre>

<h3 id="Leading_zeros_and_decimal_points">Leading zeros and decimal points</h3>

<p>You cannot use leading zeros, like 01, and decimal points must be followed by at least one digit.</p>

<pre class="brush: js example-bad">JSON.parse('{"foo": 01}');
// SyntaxError: JSON.parse: expected ',' or '}' after property value
// in object at line 1 column 2 of the JSON data

JSON.parse('{"foo": 1.}');
// SyntaxError: JSON.parse: unterminated fractional number
// at line 1 column 2 of the JSON data
</pre>

<p>Instead write just 1 without a zero and use at least one digit after a decimal point:</p>

<pre class="brush: js example-good">JSON.parse('{"foo": 1}');
JSON.parse('{"foo": 1.0}');
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("JSON")}}</li>
 <li>{{jsxref("JSON.parse()")}}</li>
 <li>{{jsxref("JSON.stringify()")}}</li>
</ul>
